From 5e7cd7aa327a5c00a90b9cde8c6ea88f5680165a Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Fr=C3=A9d=C3=A9ric=20P=C3=A9ters?= <fpeters@entrouvert.com>
Date: Thu, 28 Mar 2019 08:36:51 +0100
Subject: [PATCH] misc: add slugs to visualizations (#30855)

---
 bijoe/visualization/forms.py                  |    2 +-
 .../migrations/0003_visualization_slug.py     |   42 +
 .../migrations/0004_auto_20190328_0825.py     |   20 +
 bijoe/visualization/models.py                 |   19 +
 bijoe/visualization/views.py                  |    1 +
 tests/fixtures/schema2/01_fixture.json        | 1290 +++++++++++------
 tests/test_views.py                           |    9 +
 7 files changed, 952 insertions(+), 431 deletions(-)
 create mode 100644 bijoe/visualization/migrations/0003_visualization_slug.py
 create mode 100644 bijoe/visualization/migrations/0004_auto_20190328_0825.py

diff --git a/bijoe/visualization/forms.py b/bijoe/visualization/forms.py
index 6e34d7b..0f1156a 100644
--- a/bijoe/visualization/forms.py
+++ b/bijoe/visualization/forms.py
@@ -43,7 +43,7 @@ from . import models
 class VisualizationForm(ModelForm):
     class Meta:
         model = models.Visualization
-        exclude = ('parameters',)
+        exclude = ('slug', 'parameters',)
         widgets = {
             'name': TextInput,
         }
diff --git a/bijoe/visualization/models.py b/bijoe/visualization/models.py
index 8140ab7..7fad684 100644
--- a/bijoe/visualization/models.py
+++ b/bijoe/visualization/models.py
@@ -18,6 +18,7 @@ import json
 import datetime
 
 from django.db import models
+from django.utils.text import slugify
 from django.utils.translation import ugettext_lazy as _
 from jsonfield import JSONField
 
@@ -33,6 +34,7 @@ class JSONEncoder(json.JSONEncoder):
 
 
 class Visualization(models.Model):
+    slug = models.SlugField(verbose_name=_('Identifier'), unique=True)
     name = models.TextField(verbose_name=_('name'))
     parameters = JSONField(verbose_name=_('parameters'), encoder_class=JSONEncoder)
 
@@ -43,3 +45,20 @@ class Visualization(models.Model):
 
     def __unicode__(self):
         return self.name
+
+    def natural_key(self):
+        return (self.slug,)
+
+    def save(self, *args, **kwargs):
+        if not self.slug:
+            slug = base_slug = slugify(self.name)[:60].strip('-')
+            i = 1
+            while True:
+                try:
+                    Visualization.objects.get(slug=slug)
+                except Visualization.DoesNotExist:
+                    break
+                i += 1
+                slug = '%s-%s' % (base_slug, i)
+            self.slug = slug
+        return super(Visualization, self).save(*args, **kwargs)
diff --git a/bijoe/visualization/views.py b/bijoe/visualization/views.py
index 1c67c1c..d870062 100644
--- a/bijoe/visualization/views.py
+++ b/bijoe/visualization/views.py
@@ -216,6 +216,7 @@ class VisualizationsJSONView(MultipleObjectMixin, View):
             data_uri = reverse('visualization-json', kwargs={'pk': visualization.pk})
             data.append({
                 'name': visualization.name,
+                'slug': visualization.slug,
                 'path': request.build_absolute_uri(path),
                 'data-url': request.build_absolute_uri(data_uri),
             })
diff --git a/tests/test_views.py b/tests/test_views.py
index 054347e..88263be 100644
--- a/tests/test_views.py
+++ b/tests/test_views.py
@@ -35,6 +35,15 @@ def test_superuser(app, admin):
     app.get('/', status=200)
 
 
+def test_visualizations_json_api(schema1, app, admin):
+    Visualization(name='test', parameters={}).save()
+    Visualization(name='test', parameters={}).save()
+    Visualization(name='test', parameters={}).save()
+    login(app, admin)
+    resp = app.get(reverse('visualizations-json'))
+    assert set([x['slug'] for x in resp.json]) == set(['test', 'test-2', 'test-3'])
+
+
 def test_visualization_json_api(schema1, app, admin):
     visualization = Visualization(
             name='test',
-- 
2.20.1

